#!/usr/bin/env python
from distutils.core import setup
import os, sys

setup (name = "demo",
       version='1.0',
       description = "Demo for CDAT",
       url = "http://cdat.sf.net",
       packages = ['demo'],
       package_dir = {'demo': 'Lib'},
       scripts = ['Script/cdatdemo'],
       data_files = [('bin/images', ['Script/images/about.gif',
                                     'Script/images/air_pollution.gif',
                                     'Script/images/air_pollution_ss.gif',
                                     'Script/images/application_development.gif',
                                     'Script/images/cdat_overview.gif',
                                     'Script/images/cdat_overview_ss.gif',
                                     'Script/images/CDAT_architecture.gif',
                                     'Script/images/CDAT_modularity.gif',
                                     'Script/images/data_access.gif',
                                     'Script/images/data_access_ss.gif',
                                     'Script/images/data_analysis.gif',
                                     'Script/images/diagnostics.gif',
                                     'Script/images/earth_sciences.gif',
                                     'Script/images/engineering.gif',
                                     'Script/images/engineering_ss.gif',
                                     'Script/images/main_background.gif',
                                     'Script/images/main_background2.gif',
                                     'Script/images/pcmdi.gif',
                                     'Script/images/space_physics.gif',
                                     'Script/images/splash_screen.gif',
                                     'Script/images/visualization.gif',
                                     'Script/images/xmgrace.gif']),
                      ('bin/tutorials', ['Script/tutorials/test_wk_01.py',
                                         'Script/tutorials/adv_subset.py',
                                         'Script/tutorials/animate.py',
                                         'Script/tutorials/average_var.py',
                                         'Script/tutorials/boxfill_file.py',
                                         'Script/tutorials/CDMS_Basics_1.py',
                                         'Script/tutorials/CDMS_Basics_2.py',
                                         'Script/tutorials/CDMS_Basics_3.py',
                                         'Script/tutorials/change_datatype.py',
                                         'Script/tutorials/change_date.py',
                                         'Script/tutorials/change_variable.py',
                                         'Script/tutorials/compare_datasets.py',
                                         'Script/tutorials/coord_conv.py',
                                         'Script/tutorials/continents_file.py',
                                         'Script/tutorials/extract_and_plot.py',
                                         'Script/tutorials/eztemplate_legend_horiz_per_row.py',
                                         'Script/tutorials/eztemplate_legend_mix_local_global.py',
                                         'Script/tutorials/eztemplate_legend_side_each.py',
                                         'Script/tutorials/eztemplate_legend_vert_per_row.py',
                                         'Script/tutorials/eztemplate_margins_legend_direction.py',
                                         'Script/tutorials/eztemplate_margins_legend_thickness.py',
                                         'Script/tutorials/eztemplate_reverse.py',
                                         'Script/tutorials/eztemplate_simple.py',
                                         'Script/tutorials/eztemplate_spacing.py',
                                         'Script/tutorials/Files_1.py',
                                         'Script/tutorials/Files_2.py',
                                         'Script/tutorials/Files_3.py',
                                         'Script/tutorials/Files_5.py',
                                         'Script/tutorials/global_anomalies.py',
                                         'Script/tutorials/index.py',
                                         'Script/tutorials/isofill_file.py',
                                         'Script/tutorials/isoline_file.py',
                                         'Script/tutorials/skew-t-basic.py',
                                         'Script/tutorials/skew-t-more.py',
                                         'Script/tutorials/skew-t-windbarbs.py',
                                         'Script/tutorials/spinning_earth.py',                                         
                                         'Script/tutorials/Loops_1.py',
                                         'Script/tutorials/Loops_2.py',
                                         'Script/tutorials/Loops_3.py',
                                         'Script/tutorials/mask_variable.py',
                                         'Script/tutorials/open_and_plot.py',
                                         'Script/tutorials/orientation_and_output.py',
                                         'Script/tutorials/output_file.py',
                                         'Script/tutorials/overlay_file.py',
                                         'Script/tutorials/plot_keyword_arguments.py',
                                         'Script/tutorials/primitive_file.py',
                                         'Script/tutorials/redecorate.py',
                                         'Script/tutorials/regrid_mask_anomaly.py',
                                         'Script/tutorials/scan_var.py',
                                         'Script/tutorials/scatter_file.py',
                                         'Script/tutorials/show_continents.py',
                                         'Script/tutorials/simple_x_y_line_plot.py',
                                         'Script/tutorials/spatial_subset.py',
                                         'Script/tutorials/statistics_tutorial.py',
                                         'Script/tutorials/td.py',
                                         'Script/tutorials/template_file.py',
                                         'Script/tutorials/temporal_subset.py',
                                         'Script/tutorials/Variables_and_Axes_1.py',
                                         'Script/tutorials/Variables_and_Axes_2.py',
                                         'Script/tutorials/vector_file.py',
                                         'Script/tutorials/vertical_subset.py',
                                         'Script/tutorials/write_ioapi.py',
                                         'Script/tutorials/write_netCDF.py',
                                         'Script/tutorials/xmgrace_tutorial_Numeric.py']),
                   ('bin/tutorials/WK', ['Script/tutorials/WK/data.nc',
                                         'Script/tutorials/WK/results.nc',
                                         'Script/tutorials/WK/colormap.scr']),
                     ]
      )
