c$$$####################################################################
c$$$##     Copyright (C) 2005 Alexis Zubrow
c$$$##
c$$$##     This program is free software; you can redistribute it and/or modify
c$$$##     it under the terms of the GNU General Public License as published by
c$$$##     the Free Software Foundation; either version 2 of the License, or
c$$$##     (at your option) any later version.
c$$$##
c$$$##     This program is distributed in the hope that it will be useful,
c$$$##     but WITHOUT ANY WARRANTY; without even the implied warranty of
c$$$##     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c$$$##     GNU General Public License for more details.
c$$$##
c$$$##     You should have received a copy of the GNU General Public License
c$$$##     along with this program; if not, write to the Free Software
c$$$##     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c$$$####################################################################


      subroutine read_var(a,file, var_name, nsteps, nlays, nrows, ncols,
     &     date, start_time, tstep, lay)
c
c     Reads a variable from an IOAPI file and returns a
c     1 D array of length (nsteps*nlays*nrows*ncols)
c
      
      implicit none

      include "IODECL3.EXT"
      include "PARMS3.EXT"
      include "FDESC3.EXT"
      
c     number of layers, rows, and columns
      integer ncols, nrows, nlays  
c     layer number (1 based), -1 = all layers
      integer  lay                  
c     start date, YYYYDDD format
      integer  date           
c     start tim, HHMMSS format
      integer  start_time 
c     length of time step, HHMMSS format
      integer  tstep                
c     number of time steps
      integer  nsteps
c     size of array is the dimensions multiplied together
      real  a(nsteps* nlays* nrows* ncols)
      character*16  file
      character*16  var_name
      logical  status, read4d
      external  read4d

!! These give intent to f2py
cf2py intent(in) :: file, var_name, ncols, nrows, nlays, lay, date, start_time, tstep, nsteps
cf2py intent(out) a
cf2py depend(nsteps, nlays, nrows, ncols) a


! read data

      status = read4d(file, var_name, lay, date, start_time, 
     &     tstep, nsteps, a)

      if (status) then
         print *, "read_var successfully read ", var_name
      else
         print *, "error in read_var, problem reading ", var_name
      endif

      end


! ----------------------------------------------------------------------
 
