c$$$####################################################################
c$$$##     Copyright (C) 2005 Alexis Zubrow
c$$$##
c$$$##     This program is free software; you can redistribute it and/or modify
c$$$##     it under the terms of the GNU General Public License as published by
c$$$##     the Free Software Foundation; either version 2 of the License, or
c$$$##     (at your option) any later version.
c$$$##
c$$$##     This program is distributed in the hope that it will be useful,
c$$$##     but WITHOUT ANY WARRANTY; without even the implied warranty of
c$$$##     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c$$$##     GNU General Public License for more details.
c$$$##
c$$$##     You should have received a copy of the GNU General Public License
c$$$##     along with this program; if not, write to the Free Software
c$$$##     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
c$$$####################################################################

      subroutine write_var(a,file, var_name, nsteps, nlays, 
     &     nrows, ncols,  date, start_time, tstep, status)
c
c     Writes a variable to an IOAPI file and returns a
c     1 D array of length (nsteps*nlays*nrows*ncols)
c
      implicit none


      include "IODECL3.EXT"
      include "PARMS3.EXT"
      include "FDESC3.EXT"
      
c     number of layers, rows, and columns
      integer nlays, nrows, ncols
c     start date, YYYYDDD format
      integer date           
c     start tim, HHMMSS format
      integer start_time 
c     length of time step, HHMMSS format
      integer  tstep                
c     number of time steps
      integer  nsteps
c     size of array is the dimensions multiplied together
      real a(nsteps*nlays*nrows*ncols)
      character*16 file
      character*16 var_name
      logical status, write4d
      external write4d
      
cc These give intent to f2py
cf2py intent(in) :: file, var_name, date, start_time, tstep, nsteps, nlays, nrows, ncols
cccf2py intent(in), depend(nsteps,nlays,nrows,ncols) :: a
cf2py intent(in):: a
cf2py intent(out) :: status

c Open file and write data
      status = write4d(file, var_name, date, start_time,tstep, nsteps,a) 

      if (status) then
         print *, "Write_var successfully wrote variable ", var_name
      else
         print *, "Error in write_var command"
      endif


      end

! ----------------------------------------------------------------------
